<?php

namespace eindwerk\Entity;

use Psr\Container\ContainerInterface;

class Task
{
    protected $container;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    public function getTasks(): array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
        SELECT T.name, T.description, T.state_id, E.user_name, T.id, T.row, T.time
        FROM task T
        JOIN project P on T.project_id = p.id
        JOIN employee E on T.assignee_id = E.id
        WHERE T.project_id = 1
		ORDER BY row
        '); 
        
        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }

    public function getStates(): array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
        SELECT state.id, state.name
        FROM state
        '); 
        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }
}
