<?php

namespace eindwerk\Entity;

use Psr\Container\ContainerInterface;

class User
{
    private $username;
    protected $container;

    public function __construct(ContainerInterface $container, string $username)
    {
        $this->username = $username;
        $this->container = $container;
    }

    public function setUsername($username)
    {
        $this->username = $username;
    }

    public function getUsername(): string
    {
        return $this->username;
    }

    public function getProjects(): array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
            select P.id, P.name
            FROM project P
            JOIN team T on P.team_id = T.id
            JOIN team_member M on M.team_id = T.id
            JOIN employee E on E.id = M.employee_id
            WHERE E.user_name = :name
        ');
        $query->bindValue(':name', $this->getUsername());
        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }

    public function getTasks(): array
    {
        $db = $this->container->get('db');
        $query = $db->prepare('
        SELECT T.description
        FROM task T
        JOIN project P on T.project_id = p.id
        WHERE T.project_id = 1
        '); // 1 vervangen door id van geklikte project
        $res = $query->execute();
        $data = [];
        while ($row = $res->fetchArray(SQLITE3_ASSOC)) {
            array_push($data, $row);
        }
        return $data;
    }
}
