<?php

namespace eindwerk\Middleware;

use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Server\RequestHandlerInterface as RequestHandler;
use Slim\Psr7\Response;
use Psr\Container\ContainerInterface;
use eindwerk\Entity\User;

class AuthMiddleware
{
    protected $container;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    public function __invoke(Request $request, RequestHandler $handler): Response
    {
        $token = $request->getHeader('Authorization')[0];

        if ($token && $token != 'false') {
            $username = $this->validateToken($token);
            if ($username) {
                $request = $request->withAttribute('username', $username);
                $request = $request->withAttribute('token', $token);
                $user = new User($this->container, $username);
                $request = $request->withAttribute('user', $user);
                return $handler->handle($request);
            }
        }

        $response = new Response();
        return $response->withStatus(401);
    }

    protected function validateToken($token)
    {
        $redis = $this->container->get('redis');
        $name = $redis->get($token);
        return $name;
    }
}

